# $Revision: 1.172 $, $Date: 2008-04-08 23:20:45 $
#
# TODO:
# - put together a default .config that makes sense for desktops
# - make sure patch numbering is consistent and prepare it
#   for the future
# - investigate ppc-ICE patches from kernel.spec (does it fix the e1000 ICE?)
# - investigate pwc-uncompress patch from kernel.spec
# - investigate apparmor-caps patch from kernel.spec
# - actively search for other superb enhancing patches
#   (even the experimental ones, as kernel-desktop is not
#   mainline kernel)
# - check if we don't have newer netfilter (kernel.spec claims 2007) # - check for all patches update
# - links and descriptions above al PatchesXXX and %patchXXX
#
# Conditional build:
%bcond_without	source		# don't build kernel-source package
%bcond_with		preemptrt	# use realtime-preempt patch
%bcond_without	tuxonice	# support for tuxonice (ex-suspend2)
%bcond_with		fcache		# Jens Axboe's fcache patch (ext3 only)
%bcond_without	ck			# Con Kolivas desktop improvements patchset
%bcond_without	reiser4		# support for reiser4 fs (experimental)
%bcond_without	squashfs	# support for squashfs
%bcond_with		supermount	# support for supermount-ng
%bcond_without	unionfs		# support for unionfs
%bcond_with		grsec_minimal	# don't build grsecurity (minimal subset: proc,link,fifo,shm)
%bcond_with		bootsplash	# build with bootsplash instead of fbsplash
%bcond_without	imq			# imq
%bcond_without	wrr			# wrr support
%bcond_with		laptop		# build with HZ=100
%bcond_with		verbose		# verbose build (V=1)
%bcond_with		pae			# build PAE (HIGHMEM64G) support on uniprocessor
%bcond_with		gcc4		# build with gcc4

%{?debug:%define with_verbose 1}

%if %{with bootsplash}
%undefine	with_fbsplash
%else
%define		with_fbsplash	1
%endif

%ifnarch %{ix86}
%undefine	with_pae
%endif

%ifarch %{ix86} ppc
%define		have_isa	1
%else
%define		have_isa	0
%endif

%define		_enable_debug_packages			0

%define		netfilter_snap		20061213

%if %{with laptop}
%define		alt_kernel	laptop%{?with_preemptrt:_rt}
%else
%define		alt_kernel	desktop%{?with_preemptrt:_rt}
%endif

%define		_basever	2.6.24
%define		_postver	.4
%define		_rel		0.1
%define		_rc	%{nil}
%define		pname	kernel-desktop
Summary:	The Linux kernel (the core of the Linux operating system)
Summary(de.UTF-8):	Der Linux-Kernel (Kern des Linux-Betriebssystems)
Summary(et.UTF-8):	Linuxi kernel (ehk operatsioonisüsteemi tuum)
Summary(fr.UTF-8):	Le Kernel-Linux (La partie centrale du systeme)
Summary(pl.UTF-8):	Jądro Linuksa
Name:		kernel-%{alt_kernel}
Version:	%{_basever}%{_postver}
Release:	%{_rel}
Epoch:		3
License:	GPL v2
Group:		Base/Kernel
Source0:	http://www.kernel.org/pub/linux/kernel/v2.6/linux-%{_basever}.tar.bz2
# Source0-md5:	3f23ad4b69d0a552042d1ed0f4399857
Source1:	http://www.kernel.org/pub/linux/kernel/v2.6/patch-%{version}.bz2
# Source1-md5:	508f5aaa99dead9836ff490496a61581
Source19:	kernel-vanilla-module-build.pl
Source20:	kernel-config.py
Source21:	kernel-config-update.py
Source22:	kernel-multiarch.make

Source3:	%{pname}-autoconf.h
Source4:	%{pname}-config.h
Source5:	%{pname}-module-build.pl
Source6:	%{pname}-common.config
Source7:	%{pname}-i386.config
Source8:	%{pname}-x86_64.config
Source9:	%{pname}-ppc.config
Source10:	%{pname}-preempt-rt.config
Source11:	%{pname}-preempt-nort.config
Source12:	%{pname}-suspend2.config
Source13:	%{pname}-patches.config
Source14:	%{pname}-netfilter.config
Source15:	%{pname}-grsec.config
Source16:	%{pname}-wrr.config
Source17:	%{pname}-fbsplash.config
Source18:	%{pname}-bootsplash.config

###
#	Patches
###

#Patch0:		%{pname}-preempt-rt.patch

# Project suspend2 renamed to tuxonice
# http://www.tuxonice.net/downloads/all/tuxonice-3.0-rc5-for-2.6.24.patch.bz2
Patch1:		%{pname}-tuxonice.patch

# Jens Axboe's fcache patch (for ext3 only)
# http://git.kernel.dk/?p=linux-2.6-block.git;a=commitdiff;h=118e3e9250ef319b6e77cdbc25dc4d26084c14f
# http://en.opensuse.org/Fcache-howto
Patch6:		%{pname}-fcache.patch

### Con Kolivas patchset
# http://waninkoko.info/ckpatches/2.6.24/
Patch7:		%{pname}-ck.patch

Patch9:		%{pname}-grsec-minimal.patch

### filesystems
# previously based on ftp://ftp.namesys.com/pub/reiser4-for-2.6/2.6.22/reiser4-for-2.6.22-2.patch.gz
# now based on ftp.kernel.org:/pub/linux/kernel/people/akpm/patches/2.6/2.6.24-rc8/2.6.24-rc8-mm1/broken-out/reiser4*
Patch10:	%{pname}-reiser4.patch

# http://mesh.dl.sourceforge.net/sourceforge/squashfs/squashfs3.3.tgz
# squashfs3.3/kernel-patches/linux-2.6.24/squashfs3.3-patch
Patch11:	%{pname}-squashfs.patch

# http://dl.sourceforge.net/sourceforge/supermount-ng/supermount-ng-2.2.2-2.6.22.1_madgus_gcc34.patch.gz
Patch12:	%{pname}-supermount-ng.patch

# http://download.filesystems.org/unionfs/unionfs-2.x/unionfs-2.2.2_for_2.6.24-rc7.diff.gz
Patch13:	%{pname}-unionfs.patch

### hardware
# tahoe9XX http://tahoe.pl/drivers/tahoe9xx-2.6.11.5.patch
Patch20:	%{pname}-tahoe9xx.patch

# http://dev.gentoo.org/~spock/projects/vesafb-tng/archive/vesafb-tng-1.0-rc2-2.6.20-rc2.patch
#Patch22:	%{pname}-vesafb-tng.patch

# http://pred.dcaf-security.org/sata_nv-ncq-support-mcp51-mcp55-mcp61.patch
# NCQ Functionality for newer nvidia chipsets (MCP{51,55,61}) by nvidia crew
#Patch25:	%{pname}-sata_nv-ncq.patch
# http://memebeam.org/free-software/toshiba_acpi/toshiba_acpi-dev_toshiba_test5-linux_2.6.21.patch
Patch26:	%{pname}-toshiba-acpi.patch

### console
# ftp://ftp.openbios.org/pub/bootsplash/kernel/bootsplash-3.1.6-2.6.21.diff.gz
Patch30:	%{pname}-bootsplash.patch
# based on http://dev.gentoo.org/~spock/projects/gensplash/archive/fbsplash-0.9.2-r5-2.6.20-rc6.patch
Patch31:	%{pname}-fbsplash.patch

########	netfilter snap
## base
Patch40:	%{pname}-pom-ng-IPV4OPTSSTRIP.patch
Patch41:	%{pname}-pom-ng-ipv4options.patch
Patch42:	%{pname}-pom-ng-set.patch
Patch43:	%{pname}-pom-ng-u32.patch
Patch44:	%{pname}-pom-ng-ROUTE.patch
Patch45:	%{pname}-pom-ng-TARPIT.patch
Patch46:	%{pname}-pom-ng-mms-conntrack-nat.patch
Patch47:	%{pname}-pom-ng-IPMARK.patch
Patch48:	%{pname}-pom-ng-connlimit.patch
Patch49:	%{pname}-pom-ng-geoip.patch
Patch50:	%{pname}-pom-ng-ipp2p.patch
Patch51:	%{pname}-pom-ng-time.patch
Patch52:	%{pname}-pom-ng-rsh.patch
Patch53:	%{pname}-pom-ng-rpc.patch

# based on http://www.svn.barbara.eu.org/ipt_account/attachment/wiki/Software/ipt_account-0.1.21-20070804164729.tar.gz?format=raw
Patch67:	%{pname}-ipt_account.patch

# based on http://www.intra2net.com/de/produkte/opensource/ipt_account/pom-ng-ipt_ACCOUNT-1.10.tgz
Patch68:	%{pname}-ipt_ACCOUNT.patch

# netfilter-layer7-v2.13.tar.gz from http://l7-filter.sf.net/
Patch69:	%{pname}-layer7.patch
########	End netfilter

### net software
# based on http://www.linuximq.net/patchs/linux-2.6.24-imq.diff
# some people report problems when using imq with wrr.
Patch70:	%{pname}-imq.patch

# esfq from http://fatooh.org/esfq-2.6/current/esfq-kernel.patch
Patch71:	%{pname}-esfq.patch

# by Baggins request:
# derived from ftp://ftp.cmf.nrl.navy.mil/pub/chas/linux-atm/vbr/vbr-kernel-diffs
Patch72:	%{pname}-atm-vbr.patch
Patch73:	%{pname}-atmdd.patch

# wrr http://www.zz9.dk/patches/wrr-linux-070717-2.6.22.patch.gz
Patch74:	%{pname}-wrr.patch

# adds some ids for hostap suported cards and monitor_enable from/for aircrack-ng
# http://patches.aircrack-ng.org/hostap-kernel-2.6.18.patch
Patch75:	%{pname}-hostap.patch

# http://www.ntop.org/PF_RING.html 20070610
Patch76:	%{pname}-PF_RING.patch

# The following patch extend the routing functionality in Linux
# to support static routes (defined by user), new way to use the
# alternative routes, the reverse path protection (rp_filter),
# the NAT processing to use correctly the routing when multiple
# gateways are used.
# http://www.ssi.bg/~ja/routes-2.6.24-15.diff
# We need to disable CONFIG_IP_ROUTE_MULTIPATH_CACHED
Patch77:	%{pname}-routes.patch

### Additional features
# http://www.bullopensource.org/cpuset/ - virtual CPUs
Patch85:	%{pname}-cpuset_virtualization.patch

### Fixes
Patch91:	%{pname}-fbcon-margins.patch
Patch92:	%{pname}-static-dev.patch
Patch100:	%{pname}-small_fixes.patch
# Wake-On-Lan fix for nForce drivers; using http://atlas.et.tudelft.nl/verwei90/nforce2/wol.html
# Fix verified for that kernel version.
Patch102:	%{pname}-forcedeth-WON.patch
Patch103:	%{pname}-ueagle-atm-freezer.patch
# investigate
Patch104:	%{pname}-ppc-ICE.patch

# http://synce.svn.sourceforge.net/svnroot/synce/trunk/patches/linux-2.6.22-rndis_host-wm5.patch
Patch105:	%{pname}-rndis_host.patch

# add tty ioctl to figure physical device of the console. used by showconsole.spec (blogd)
#Patch106:	kernel-TIOCGDEV.patch

URL:		http://www.kernel.org/
BuildRequires:	/sbin/depmod
BuildRequires:	binutils >= 3:2.14.90.0.7
%{!?with_gcc4:BuildRequires:	gcc >= 5:3.2}
%{?with_gcc4:BuildRequires:	gcc >= 5:4.1.1}
BuildRequires:	module-init-tools
# for hostname command
BuildRequires:	net-tools
BuildRequires:	perl-base
BuildRequires:	rpmbuild(macros) >= 1.217
Autoreqprov:	no
Requires:	/sbin/depmod
Requires:	coreutils
Requires:	geninitrd >= 8702
Requires:	module-init-tools >= 0.9.9
%{?with_bootsplash:Suggests:	bootsplash}
%{?with_fbsplash:Suggests:	splashutils}
Provides:	%{name}(netfilter) = %{netfilter_snap}
Provides:	kernel(netfilter) = %{netfilter_snap}
Conflicts:	e2fsprogs < 1.29
Conflicts:	isdn4k-utils < 3.1pre1
Conflicts:	jfsutils < 1.1.3
Conflicts:	module-init-tool < 0.9.10
Conflicts:	nfs-utils < 1.0.5
Conflicts:	oprofile < 0.9
Conflicts:	ppp < 1:2.4.0
Conflicts:	procps < 3.2.0
Conflicts:	quota-tools < 3.09
%if %{with reiserfs4}
Conflicts:	reiser4progs < 1.0.0
%endif
Conflicts:	reiserfsprogs < 3.6.3
Conflicts:	udev < 071
Conflicts:	util-linux < 2.10o
Conflicts:	xfsprogs < 2.6.0
ExclusiveArch:	%{ix86} %{x8664} ppc
ExclusiveOS:	Linux
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%if %{with gcc4}
# add suffix, but allow ccache, etc in ~/.rpmmacros
%{expand:%%define	__cc	%(echo '%__cc' | sed -e 's,-gcc,-gcc4,')}
%{expand:%%define	__cxx	%(echo '%__cxx' | sed -e 's,-g++,-g++4,')}
%{expand:%%define	__cpp	%(echo '%__cpp' | sed -e 's,-gcc,-gcc4,')}
%endif

%ifarch %{ix86} %{x8664}
%define		target_arch_dir	x86
%else
%define		target_arch_dir	%{_target_base_arch}
%endif

# No ELF objects there to strip (skips processing 27k files)
%define		_noautostrip	.*%{_kernelsrcdir}/.*
%define		_noautochrpath	.*%{_kernelsrcdir}/.*

%define		initrd_dir	/boot

%define		topdir	%{_builddir}/%{name}-%{version}
%define		srcdir	%{topdir}/linux-%{_basever}
%define		objdir	%{topdir}/o

# kernel release (used in filesystem and eventually in uname -r)
# modules will be looked from /lib/modules/%{kernel_release}
# _localversion is just that without version for "> localversion"
%define		_localversion %{release}
%define		kernel_release %{version}_%{alt_kernel}-%{_localversion}
%define		_kernelsrcdir	/usr/src/linux-%{version}_%{alt_kernel}

%define	CommonOpts	HOSTCC="%{__cc}" HOSTCFLAGS="-Wall -Wstrict-prototypes %{rpmcflags} -fomit-frame-pointer"
%if "%{_target_base_arch}" != "%{_arch}"
	%define	MakeOpts %{CommonOpts} ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux-
	%define	DepMod /bin/true

	%if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386"
	%define	MakeOpts %{CommonOpts} CC="%{__cc}" ARCH=%{_target_base_arch}
	%define	DepMod /sbin/depmod
	%endif

%else
	%define MakeOpts %{CommonOpts} CC="%{__cc}"
	%define	DepMod /sbin/depmod
%endif

%define __features Enabled features:\
%{?debug: - DEBUG}\
%{?with_tuxonice: - TuxOnIce (formerly known as suspend2)}\
%{?with_preemptrt: - realtime-preempt patch by Ingo Molar}\
%{?with_ck: - desktop patchset by Con Kolivas}\
%{?with_grsec_minimal: - grsecurity minimal}\
 - %{?with_bootsplash:bootsplash}%{?with_fbsplash:fbsplash}\
 - HZ=100%{!?with_laptop:0}

%define Features %(echo "%{__features}" | sed '/^$/d')

%description
This package contains the Linux kernel that is used to boot and run
your system. It contains few device drivers for specific hardware.
Most hardware is instead supported by modules loaded after booting.

%{Features}

%description -l de.UTF-8
Das Kernel-Packet enthält den Linux-Kernel (vmlinuz), den Kern des
Linux-Betriebssystems. Der Kernel ist für grundliegende
Systemfunktionen verantwortlich: Speicherreservierung,
Prozeß-Management, Geräte Ein- und Ausgaben, usw.

%{Features}

%description -l fr.UTF-8
Le package kernel contient le kernel linux (vmlinuz), la partie
centrale d'un système d'exploitation Linux. Le noyau traite les
fonctions basiques d'un système d'exploitation: allocation mémoire,
allocation de process, entrée/sortie de peripheriques, etc.

%{Features}

%description -l pl.UTF-8
Pakiet zawiera jądro Linuksa niezbędne do prawidłowego działania
Twojego komputera. Zawiera w sobie sterowniki do sprzętu znajdującego
się w komputerze, takiego jak sterowniki dysków itp.

%{Features}

%package vmlinux
Summary:	vmlinux - uncompressed kernel image
Summary(de.UTF-8):	vmlinux - dekompressiertes Kernel Bild
Summary(pl.UTF-8):	vmlinux - rozpakowany obraz jądra
Group:		Base/Kernel

%description vmlinux
vmlinux - uncompressed kernel image.

%description vmlinux -l de.UTF-8
vmlinux - dekompressiertes Kernel Bild.

%description vmlinux -l pl.UTF-8
vmlinux - rozpakowany obraz jądra.

%package drm
Summary:	DRM kernel modules
Summary(de.UTF-8):	DRM Kernel Treiber
Summary(pl.UTF-8):	Sterowniki DRM
Group:		Base/Kernel
Requires:	%{name} = %{epoch}:%{version}-%{release}
Autoreqprov:	no

%description drm
DRM kernel modules.

%description drm -l de.UTF-8
DRM Kernel Treiber.

%description drm -l pl.UTF-8
Sterowniki DRM.

%package pcmcia
Summary:	PCMCIA modules
Summary(de.UTF-8):	PCMCIA Module
Summary(pl.UTF-8):	Moduły PCMCIA
Group:		Base/Kernel
Requires:	%{name} = %{epoch}:%{version}-%{release}
Conflicts:	pcmcia-cs < 3.1.21
Conflicts:	pcmciautils < 004
Autoreqprov:	no

%description pcmcia
PCMCIA modules.

%description pcmcia -l de.UTF-8
PCMCIA Module.

%description pcmcia -l pl.UTF-8
Moduły PCMCIA.

%package sound-alsa
Summary:	ALSA kernel modules
Summary(de.UTF-8):	ALSA Kernel Module
Summary(pl.UTF-8):	Sterowniki dźwięku ALSA
Group:		Base/Kernel
Requires:	%{name} = %{epoch}:%{version}-%{release}
Autoreqprov:	no

%description sound-alsa
ALSA (Advanced Linux Sound Architecture) sound drivers.

%description sound-alsa -l de.UTF-8
ALSA (Advanced Linux Sound Architecture) Sound-Treiber.

%description sound-alsa -l pl.UTF-8
Sterowniki dźwięku ALSA (Advanced Linux Sound Architecture).

%package sound-oss
Summary:	OSS kernel modules
Summary(de.UTF-8):	OSS Kernel Module
Summary(pl.UTF-8):	Sterowniki dźwięku OSS
Group:		Base/Kernel
Requires:	%{name} = %{epoch}:%{version}-%{release}
Autoreqprov:	no

%description sound-oss
OSS (Open Sound System) drivers.

%description sound-oss -l de.UTF-8
OSS (Open Sound System) Treiber.

%description sound-oss -l pl.UTF-8
Sterowniki dźwięku OSS (Open Sound System).

%package headers
Summary:	Header files for the Linux kernel
Summary(de.UTF-8):	Header Dateien für den Linux-Kernel
Summary(pl.UTF-8):	Pliki nagłówkowe jądra Linuksa
Group:		Development/Building
Provides:	%{name}-headers(netfilter) = %{netfilter_snap}
Autoreqprov:	no

%description headers
These are the C header files for the Linux kernel, which define
structures and constants that are needed when rebuilding the kernel or
building kernel modules.

%description headers -l de.UTF-8
Dies sind die C Header Dateien für den Linux-Kernel, die definierte
Strukturen und Konstante beinhalten die beim rekompilieren des Kernels
oder bei Kernel Modul kompilationen gebraucht werden.

%description headers -l pl.UTF-8
Pakiet zawiera pliki nagłówkowe jądra, niezbędne do rekompilacji jądra
oraz budowania modułów jądra.

%package module-build
Summary:	Development files for building kernel modules
Summary(de.UTF-8):	Development Dateien die beim Kernel Modul kompilationen gebraucht werden
Summary(pl.UTF-8):	Pliki służące do budowania modułów jądra
Group:		Development/Building
Requires:	%{name}-headers = %{epoch}:%{version}-%{release}
Autoreqprov:	no

%description module-build
Development files from kernel source tree needed to build Linux kernel
modules from external packages.

%description module-build -l de.UTF-8
Development Dateien des Linux-Kernels die beim kompilieren externer
Kernel Module gebraucht werden.

%description module-build -l pl.UTF-8
Pliki ze drzewa źródeł jądra potrzebne do budowania modułów jądra
Linuksa z zewnętrznych pakietów.

%package source
Summary:	Kernel source tree
Summary(de.UTF-8):	Der Kernel Quelltext
Summary(pl.UTF-8):	Kod źródłowy jądra Linuksa
Group:		Development/Building
Requires:	%{name}-module-build = %{epoch}:%{version}-%{release}
Autoreqprov:	no

%description source
This is the source code for the Linux kernel. You can build a custom
kernel that is better tuned to your particular hardware.

%description source -l de.UTF-8
Das Kernel-Source-Packet enthält den source code (C/Assembler-Code)
des Linux-Kernels. Die Source-Dateien werden gebraucht, um viele
C-Programme zu kompilieren, da sie auf Konstanten zurückgreifen, die
im Kernel-Source definiert sind. Die Source-Dateien können auch
benutzt werden, um einen Kernel zu kompilieren, der besser auf Ihre
Hardware ausgerichtet ist.

%description source -l fr.UTF-8
Le package pour le kernel-source contient le code source pour le noyau
linux. Ces sources sont nécessaires pour compiler la plupart des
programmes C, car il dépend de constantes définies dans le code
source. Les sources peuvent être aussi utilisée pour compiler un noyau
personnalisé pour avoir de meilleures performances sur des matériels
particuliers.

%description source -l pl.UTF-8
Pakiet zawiera kod źródłowy jądra systemu.

%package doc
Summary:	Kernel documentation
Summary(de.UTF-8):	Kernel Dokumentation
Summary(pl.UTF-8):	Dokumentacja do jądra Linuksa
Group:		Documentation
Autoreqprov:	no

%description doc
This is the documentation for the Linux kernel, as found in
Documentation directory.

%description doc -l de.UTF-8
Dies ist die Kernel Dokumentation wie sie im 'Documentation'
Verzeichniss vorgefunden werden kann.

%description doc -l pl.UTF-8
Pakiet zawiera dokumentację do jądra Linuksa pochodzącą z katalogu
Documentation.

%prep
%setup -qc
install -d o/scripts
ln -s %{SOURCE19} o/scripts/kernel-module-build.pl
ln -s %{SOURCE20} o/scripts/kernel-config.py
ln -s %{SOURCE21} o/scripts/kernel-config-update.py
ln -s %{SOURCE22} Makefile

cd linux-%{_basever}
%if "%{_postver}" != "%{nil}"
%{__bzip2} -dc %{SOURCE1} | %{__patch} -p1 -s
%endif

# Fix EXTRAVERSION in main Makefile
sed -i 's#EXTRAVERSION =.*#EXTRAVERSION = %{_postver}_%{alt_kernel}#g' Makefile

%if %{with tuxonice}
%patch1 -p1
%endif

%if %{with preemptrt}
#%patch0 -p1
%endif

%if %{with fcache}
%patch6 -p1
%endif

%if %{with ck}
%patch7 -p1
%endif

%if %{with grsec_minimal}
%patch9 -p1
%endif

%if %{with reiser4}
%patch10 -p1
%endif

%if %{with squashfs}
%patch11 -p1
%endif

%if %{with supermoint}
%patch12 -p1
%endif

%if %{with unionfs}
%patch13 -p1
%endif

### hardware
%patch20 -p1
%if 0
#%patch22 -p1 # UVESAFB
#%patch25 -p1 # FIND UPDATE
%endif
# toshiba-acpi
%patch26 -p1

### console
%if %{with bootsplash}
%patch30 -p1
%else
%patch31 -p1
%endif

## netfilter
#

# kernel-pom-ng-IPV4OPTSSTRIP.patch
%patch40 -p1

# kernel-pom-ng-ipv4options.patch
%patch41 -p1

# kernel-pom-ng-u32.patch
%patch43 -p1

# kernel-pom-ng-ROUTE.patch
%patch44 -p1

# kernel-pom-ng-TARPIT.patch
%patch45 -p1

# kernel-pom-ng-mms-conntrack-nat.patch
%patch46 -p1

# kernel-pom-ng-IPMARK.patch
%patch47 -p1

# kernel-pom-ng-set.patch
#patch42 -p1

# kernel-pom-ng-connlimit.patch
%patch48 -p1

# kernel-pom-ng-geoip.patch
%patch49 -p1

# kernel-pom-ng-ipp2p.patch
%patch50 -p1

# kernel-pom-ng-time.patch
%patch51 -p1

# kernel-pom-ng-rsh.patch
%patch52 -p1

# kernel-pom-ng-rpc.patch
%patch53 -p1

# kernel-ipt_account.patch
%patch67 -p1

# kernel-ipt_ACCOUNT.patch
%patch68 -p1

# kernel-layer7.patch
%patch69 -p1

##
# end of netfilter


### net software
%if %{with imq}
%patch70 -p1
%endif

%patch71 -p1
# atm-vbr
%patch72 -p1
# atmdd
%patch73 -p1

%if %{with wrr}
%patch74 -p1
%endif

# hostap enhancements from/for aircrack-ng
%patch75 -p1

# PF_RING
%patch76 -p1
# static routes
%patch77 -p1

### fixes
%patch91 -p1
%patch92 -p1
%patch100 -p1
# forcedeth
%patch102 -p1
# ueagle freezer
%patch103 -p1
# ppc ICE fixes
%ifarch ppc ppc64
%patch104 -p1
%endif
%patch105 -p1
#%patch106 -p1 # FIND UPDATE

# cleanup backups after patching
find '(' -name '*~' -o -name '*.orig' -o -name '.gitignore' ')' -print0 | xargs -0 -r -l512 rm -f

%build
cat > multiarch.make <<'EOF'
# generated by %{name}.spec
KERNELSRC		:= %{_builddir}/%{name}-%{version}/linux-%{_basever}
KERNELOUTPUT	:= %{objdir}

SRCARCH		:= %{target_arch_dir}
ARCH		:= %{_target_base_arch}
Q			:= %{!?with_verbose:@}
MAKE_OPTS	:= %{MakeOpts}

CONFIGS += %{_sourcedir}/%{pname}-common.config
CONFIGS += %{_sourcedir}/%{pname}-%{_target_base_arch}.config

# preempt
%if %{with preemptrt}
CONFIGS += %{_sourcedir}/%{pname}-preempt-rt.config
%else
CONFIGS += %{_sourcedir}/%{pname}-preempt-nort.config
%endif

# suspend 2
CONFIGS += %{_sourcedir}/%{pname}-suspend2.config

# fbsplash, vesafb-tng, squashfs, imq, tahoe, atm, reiser4
CONFIGS += %{_sourcedir}/%{pname}-patches.config

# netfilter
CONFIGS += %{_sourcedir}/%{pname}-netfilter.config

%if %{with grsec_minimal}
CONFIGS += %{_sourcedir}/%{pname}-grsec.config
%endif

# wrr
CONFIGS += %{_sourcedir}/%{pname}-wrr.config

%if %{with bootsplash}
	CONFIGS += %{_sourcedir}/%{pname}-bootsplash.config
%else
	CONFIGS += %{_sourcedir}/%{pname}-fbsplash.config
%endif

# config where we ignore timestamps
CONFIG_NODEP += %{objdir}/.kernel-autogen.conf
EOF

# update config at spec time
# if you have config file, add it to above Makefile
pykconfig() {
	set -x
	echo '# %{name}.spec overrides'
	echo 'LOCALVERSION="-%{_localversion}"'

	%{?debug:echo '# debug options'}
	%{?debug:echo 'DEBUG_SLAB=y'}
	%{?debug:echo 'DEBUG_PREEMPT=y'}
	%{?debug:echo 'RT_DEADLOCK_DETECT=y'}

%ifarch %{ix86}
	echo '# x86 tuneup'
	%ifarch i386
	echo 'M386=y'
	echo 'X86_F00F_BUG=y'
	%endif
	%ifarch i486
	echo 'M486=y'
	echo 'X86_F00F_BUG=y'
	%endif
	%ifarch i586
	echo 'M586=y'
	echo 'X86_F00F_BUG=y'
	%endif
	%ifarch i686
	echo 'M686=y'
	%endif
	%ifarch pentium3
	echo 'MPENTIUMIII=y'
	%endif
	%ifarch pentium4
	echo 'MPENTIUM4=y'
	%endif
	%ifarch athlon
	echo 'MK7=y'
	echo 'X86_PPRO_FENCE='
	echo 'X86_USE_3DNOW=y'
	%endif
	%ifarch i686 athlon pentium3 pentium4
	%if %{with pae}
		echo 'HIGHMEM4G=n'
		echo 'HIGHMEM64G=y'
		echo 'X86_PAE=y'
	%endif
	%endif
	%ifarch i686 athlon pentium3 pentium4
	# This issues 'CPU too old' error on Centrino processors
	# http://lkml.org/lkml/2007/9/18/301
#	echo 'HIGHMEM4G=n'
#	echo 'HIGHMEM64G=y'
#	echo 'X86_PAE=y:'
	echo 'MATH_EMULATION=n'
	%endif
%endif

	%ifnarch i386
		echo 'NO_HZ=n'
		echo 'HZ_1000=y'
		echo 'HZ=1000'
	%endif

	%if %{with laptop}
		echo 'HZ_1000=n'
		echo 'HZ_100=y'
		echo 'HZ=100'
	%endif

	# disable e1000 on ppc (ICEs)
	%ifarch ppc ppc64
		echo 'E1000=n'
		echo 'E1000_NAPI=n'
		echo 'E1000_DISABLE_PACKET_SPLIT=n'
	%endif
}

# generate .config and kernel.conf
pykconfig > %{objdir}/.kernel-autogen.conf
%{__make} pykconfig

# build kernel
%{__make} all

%install
rm -rf $RPM_BUILD_ROOT
# touch for noarch build (exclude list)
install -d $RPM_BUILD_ROOT%{_kernelsrcdir}/include/linux
touch $RPM_BUILD_ROOT%{_kernelsrcdir}/include/linux/{utsrelease,version,autoconf-dist}.h

%{__make} %{MakeOpts} %{!?with_verbose:-s} modules_install \
	-C %{objdir} \
	%{?with_verbose:V=1} \
	DEPMOD=%{DepMod} \
	INSTALL_MOD_PATH=$RPM_BUILD_ROOT \
	KERNELRELEASE=%{kernel_release}

mkdir $RPM_BUILD_ROOT/lib/modules/%{kernel_release}/misc
rm -f $RPM_BUILD_ROOT/lib/modules/%{kernel_release}/{build,source}
touch $RPM_BUILD_ROOT/lib/modules/%{kernel_release}/{build,source}

# /boot
install -d $RPM_BUILD_ROOT/boot
cp -a %{objdir}/System.map $RPM_BUILD_ROOT/boot/System.map-%{kernel_release}
install %{objdir}/vmlinux $RPM_BUILD_ROOT/boot/vmlinux-%{kernel_release}
%ifarch %{ix86} %{x8664}
cp -a %{objdir}/arch/%{target_arch_dir}/boot/bzImage $RPM_BUILD_ROOT/boot/vmlinuz-%{kernel_release}
%endif
%ifarch ppc ppc64
install %{objdir}/vmlinux $RPM_BUILD_ROOT/boot/vmlinuz-%{kernel_release}
%endif
%ifarch alpha sparc sparc64
	%{__gzip} -cfv %{objdir}/vmlinux > %{objdir}/vmlinuz
	cp -a %{objdir}/vmlinuz $RPM_BUILD_ROOT/boot/vmlinuz-%{kernel_release}
%ifarch sparc
	elftoaout %{objdir}/arch/sparc/boot/image -o %{objdir}/vmlinux.aout
	install %{objdir}/vmlinux.aout $RPM_BUILD_ROOT/boot/vmlinux.aout-%{kernel_release}
%endif
%ifarch sparc64
	elftoaout %{objdir}/arch/sparc64/boot/image -o %{objdir}/vmlinux.aout
	install %{objdir}/vmlinux.aout $RPM_BUILD_ROOT/boot/vmlinux.aout-%{kernel_release}
%endif
%endif

# for initrd
touch $RPM_BUILD_ROOT/boot/initrd-%{kernel_release}.gz

%if "%{_target_base_arch}" != "%{_arch}"
touch $RPM_BUILD_ROOT/lib/modules/%{kernel_release}/modules.dep
%endif

# /etc/modrobe.d
install -d $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{kernel_release}

# /usr/src/linux
# maybe package these to -module-build, then -headers could be noarch
cp -a %{objdir}/Module.symvers $RPM_BUILD_ROOT%{_kernelsrcdir}/Module.symvers-dist
cp -aL %{objdir}/.config $RPM_BUILD_ROOT%{_kernelsrcdir}/config-dist
cp -a %{objdir}/include/linux/autoconf.h $RPM_BUILD_ROOT%{_kernelsrcdir}/include/linux/autoconf-dist.h
cp -a %{objdir}/include/linux/{utsrelease,version}.h $RPM_BUILD_ROOT%{_kernelsrcdir}/include/linux

# test if we can hardlink -- %{_builddir} and $RPM_BUILD_ROOT on same partition
if cp -al %{srcdir}/COPYING $RPM_BUILD_ROOT/COPYING 2>/dev/null; then
	l=l
	rm -f $RPM_BUILD_ROOT/COPYING
fi
cp -a$l %{srcdir}/* $RPM_BUILD_ROOT%{_kernelsrcdir}

install -d $RPM_BUILD_ROOT/lib/modules/%{kernel_release}
cp -a %{SOURCE4} $RPM_BUILD_ROOT%{_kernelsrcdir}/include/linux/config.h
cp -a %{SOURCE3} $RPM_BUILD_ROOT%{_kernelsrcdir}/include/linux/autoconf.h

# collect module-build files and directories
# Usage: kernel-module-build.pl $rpmdir $fileoutdir
fileoutdir=$(pwd)
cd $RPM_BUILD_ROOT%{_kernelsrcdir}
%{objdir}/scripts/kernel-module-build.pl %{_kernelsrcdir} $fileoutdir
cd -

%clean
rm -rf $RPM_BUILD_ROOT

%preun
if [ -x /sbin/new-kernel-pkg ]; then
	/sbin/new-kernel-pkg --remove %{kernel_release}
fi

%post
mv -f /boot/vmlinuz-%{alt_kernel} /boot/vmlinuz-%{alt_kernel}.old 2>/dev/null > /dev/null
mv -f /boot/System.map-%{alt_kernel} /boot/System.map-%{alt_kernel}.old 2>/dev/null > /dev/null
ln -sf vmlinuz-%{kernel_release} /boot/vmlinuz-%{alt_kernel}
ln -sf System.map-%{kernel_release} /boot/System.map-%{alt_kernel}
if [ ! -e /boot/vmlinuz ]; then
	mv -f /boot/vmlinuz /boot/vmlinuz.old 2>/dev/null
	mv -f /boot/System.map /boot/System.map.old 2>/dev/null
	ln -sf vmlinuz-%{alt_kernel} /boot/vmlinuz
	ln -sf System.map-%{alt_kernel} /boot/System.map
	mv -f %{initrd_dir}/initrd %{initrd_dir}/initrd.old 2>/dev/null
	ln -sf initrd-%{alt_kernel} %{initrd_dir}/initrd
fi

%depmod %{kernel_release}

/sbin/geninitrd -f --initrdfs=initramfs %{?with_bootsplash:--with-bootsplash} %{?with_fbsplash:--with-fbsplash} %{initrd_dir}/initrd-%{kernel_release}.gz %{kernel_release}
mv -f %{initrd_dir}/initrd-%{alt_kernel} %{initrd_dir}/initrd-%{alt_kernel}.old 2>/dev/null
ln -sf initrd-%{kernel_release}.gz %{initrd_dir}/initrd-%{alt_kernel}

if [ -x /sbin/new-kernel-pkg ]; then
	if [ -f /etc/pld-release ]; then
		title=$(sed 's/^[0-9.]\+ //' < /etc/pld-release)
	else
		title='PLD Linux'
	fi

	title="$title %{alt_kernel}"

	/sbin/new-kernel-pkg --initrdfile=%{initrd_dir}/initrd-%{kernel_release}.gz --install %{kernel_release} --banner "$title"
elif [ -x /sbin/rc-boot ]; then
	/sbin/rc-boot 1>&2 || :
fi

%post vmlinux
mv -f /boot/vmlinux-%{alt_kernel} /boot/vmlinux-%{alt_kernel}.old 2>/dev/null
ln -sf vmlinux-%{kernel_release} /boot/vmlinux-%{alt_kernel}

%post drm
%depmod %{kernel_release}

%postun drm
%depmod %{kernel_release}

%post pcmcia
%depmod %{kernel_release}

%postun pcmcia
%depmod %{kernel_release}

%post sound-alsa
%depmod %{kernel_release}

%postun sound-alsa
%depmod %{kernel_release}

%post sound-oss
%depmod %{kernel_release}

%postun sound-oss
%depmod %{kernel_release}

%post headers
rm -f %{_prefix}/src/linux-%{alt_kernel}
ln -snf %{basename:%{_kernelsrcdir}} %{_prefix}/src/linux-%{alt_kernel}

%postun headers
if [ "$1" = "0" ]; then
	if [ -L %{_prefix}/src/linux-%{alt_kernel} ]; then
		if [ "$(readlink %{_prefix}/src/linux-%{alt_kernel})" = "linux-%{version}_%{alt_kernel}" ]; then
			rm -f %{_prefix}/src/linux-%{alt_kernel}
		fi
	fi
fi

%triggerin module-build -- %{name} = %{epoch}:%{version}-%{release}
ln -sfn %{_kernelsrcdir} /lib/modules/%{kernel_release}/build
ln -sfn %{_kernelsrcdir} /lib/modules/%{kernel_release}/source

%triggerun module-build -- %{name} = %{epoch}:%{version}-%{release}
if [ "$1" = 0 ]; then
	rm -f /lib/modules/%{kernel_release}/{build,source}
fi

%files
%defattr(644,root,root,755)
/boot/vmlinuz-%{kernel_release}
/boot/System.map-%{kernel_release}
%ghost /boot/initrd-%{kernel_release}.gz
%dir /lib/modules/%{kernel_release}
%dir /lib/modules/%{kernel_release}/kernel
/lib/modules/%{kernel_release}/kernel/arch
/lib/modules/%{kernel_release}/kernel/crypto
/lib/modules/%{kernel_release}/kernel/drivers
%exclude /lib/modules/%{kernel_release}/kernel/drivers/char/drm
/lib/modules/%{kernel_release}/kernel/fs
/lib/modules/%{kernel_release}/kernel/kernel
/lib/modules/%{kernel_release}/kernel/lib
/lib/modules/%{kernel_release}/kernel/net
%dir /lib/modules/%{kernel_release}/kernel/sound
/lib/modules/%{kernel_release}/kernel/sound/soundcore.*
%exclude /lib/modules/%{kernel_release}/kernel/drivers/media/video/*/*-alsa.ko*
%dir /lib/modules/%{kernel_release}/misc
%exclude /lib/modules/%{kernel_release}/kernel/drivers/pcmcia
%exclude /lib/modules/%{kernel_release}/kernel/drivers/*/pcmcia
%exclude /lib/modules/%{kernel_release}/kernel/drivers/bluetooth/*_cs.ko*
%exclude /lib/modules/%{kernel_release}/kernel/drivers/ide/legacy/ide-cs.ko*
%exclude /lib/modules/%{kernel_release}/kernel/drivers/isdn/hardware/avm/avm_cs.ko*
%exclude /lib/modules/%{kernel_release}/kernel/drivers/net/wireless/*_cs.ko*
%exclude /lib/modules/%{kernel_release}/kernel/drivers/net/wireless/hostap/hostap_cs.ko*
%exclude /lib/modules/%{kernel_release}/kernel/drivers/parport/parport_cs.ko*
%exclude /lib/modules/%{kernel_release}/kernel/drivers/serial/serial_cs.ko*
%exclude /lib/modules/%{kernel_release}/kernel/drivers/telephony/ixj_pcmcia.ko*
%exclude /lib/modules/%{kernel_release}/kernel/drivers/usb/host/sl811_cs.ko*
%ghost /lib/modules/%{kernel_release}/modules.*
%ghost /lib/modules/%{kernel_release}/build
%ghost /lib/modules/%{kernel_release}/source
%dir %{_sysconfdir}/modprobe.d/%{kernel_release}

%ifarch alpha %{ix86} %{x8664} sparc sparc64
%files vmlinux
%defattr(644,root,root,755)
/boot/vmlinux-%{kernel_release}
%endif

%files drm
%defattr(644,root,root,755)
/lib/modules/%{kernel_release}/kernel/drivers/char/drm

%files pcmcia
%defattr(644,root,root,755)
/lib/modules/%{kernel_release}/kernel/drivers/pcmcia
/lib/modules/%{kernel_release}/kernel/drivers/*/pcmcia
/lib/modules/%{kernel_release}/kernel/drivers/bluetooth/*_cs.ko*
/lib/modules/%{kernel_release}/kernel/drivers/ide/legacy/ide-cs.ko*
/lib/modules/%{kernel_release}/kernel/drivers/isdn/hardware/avm/avm_cs.ko*
/lib/modules/%{kernel_release}/kernel/drivers/net/wireless/*_cs.ko*
/lib/modules/%{kernel_release}/kernel/drivers/net/wireless/hostap/hostap_cs.ko*
/lib/modules/%{kernel_release}/kernel/drivers/parport/parport_cs.ko*
/lib/modules/%{kernel_release}/kernel/drivers/serial/serial_cs.ko*
/lib/modules/%{kernel_release}/kernel/drivers/telephony/ixj_pcmcia.ko*
/lib/modules/%{kernel_release}/kernel/drivers/usb/host/sl811_cs.ko*
/lib/modules/%{kernel_release}/kernel/sound/pcmcia

%files sound-alsa
%defattr(644,root,root,755)
/lib/modules/%{kernel_release}/kernel/sound
/lib/modules/%{kernel_release}/kernel/drivers/media/video/*/*-alsa.ko*
%exclude %dir /lib/modules/%{kernel_release}/kernel/sound
%exclude /lib/modules/%{kernel_release}/kernel/sound/soundcore.*
%exclude /lib/modules/%{kernel_release}/kernel/sound/oss
%exclude /lib/modules/%{kernel_release}/kernel/sound/pcmcia

%files sound-oss
%defattr(644,root,root,755)
/lib/modules/%{kernel_release}/kernel/sound/oss

%files headers
%defattr(644,root,root,755)
%dir %{_kernelsrcdir}
%{_kernelsrcdir}/include
%{_kernelsrcdir}/config-dist
%{_kernelsrcdir}/Module.symvers-dist

%files module-build -f aux_files
%defattr(644,root,root,755)
%{_kernelsrcdir}/Kbuild
%{_kernelsrcdir}/arch/*/kernel/asm-offsets.*
%{_kernelsrcdir}/arch/*/kernel/sigframe.h
%dir %{_kernelsrcdir}/scripts
%dir %{_kernelsrcdir}/scripts/kconfig
%{_kernelsrcdir}/scripts/Kbuild.include
%{_kernelsrcdir}/scripts/Makefile*
%{_kernelsrcdir}/scripts/basic
%{_kernelsrcdir}/scripts/mkmakefile
%{_kernelsrcdir}/scripts/mod
%{_kernelsrcdir}/scripts/setlocalversion
%{_kernelsrcdir}/scripts/*.c
%{_kernelsrcdir}/scripts/*.sh
%{_kernelsrcdir}/scripts/kconfig/*

%files doc
%defattr(644,root,root,755)
%{_kernelsrcdir}/Documentation

%if %{with source}
%files source -f aux_files_exc
%defattr(644,root,root,755)
%{_kernelsrcdir}/arch/*/[!Mk]*
%{_kernelsrcdir}/arch/*/kernel/[!M]*
%exclude %{_kernelsrcdir}/arch/*/kernel/asm-offsets.*
%exclude %{_kernelsrcdir}/arch/*/kernel/sigframe.h
%{_kernelsrcdir}/block
%{_kernelsrcdir}/crypto
%{_kernelsrcdir}/drivers
%{_kernelsrcdir}/fs
%if %{with grsec_minimal}
%{_kernelsrcdir}/grsecurity
%endif
%{_kernelsrcdir}/init
%{_kernelsrcdir}/ipc
%{_kernelsrcdir}/kernel
%{_kernelsrcdir}/lib
%{_kernelsrcdir}/mm
%{_kernelsrcdir}/net
%{_kernelsrcdir}/scripts/*
%exclude %{_kernelsrcdir}/scripts/Kbuild.include
%exclude %{_kernelsrcdir}/scripts/Makefile*
%exclude %{_kernelsrcdir}/scripts/basic
%exclude %{_kernelsrcdir}/scripts/kconfig
%exclude %{_kernelsrcdir}/scripts/mkmakefile
%exclude %{_kernelsrcdir}/scripts/mod
%exclude %{_kernelsrcdir}/scripts/setlocalversion
%exclude %{_kernelsrcdir}/scripts/*.c
%exclude %{_kernelsrcdir}/scripts/*.sh
%{_kernelsrcdir}/sound
%{_kernelsrcdir}/security
%{_kernelsrcdir}/usr
%{_kernelsrcdir}/COPYING
%{_kernelsrcdir}/CREDITS
%{_kernelsrcdir}/MAINTAINERS
%{_kernelsrcdir}/README
%{_kernelsrcdir}/REPORTING-BUGS
%endif

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: kernel-desktop.spec,v $
Revision 1.172  2008-04-08 23:20:45  glen
- updated most of the patches from kernel:LINUX_2_6 branch
- update ck patch
- add bconds for major patchsets
- drop patches that were long time not updated

Revision 1.171  2008-03-27 19:27:34  glen
- 2.6.24.4

Revision 1.170  2008-03-02 19:53:30  glen
- apply -rndis_host.patch

Revision 1.169  2008-03-01 15:06:18  glen
- finish %install part

Revision 1.168  2008-03-01 13:47:41  glen
- %prep, %build from kernel-vanilla build system

Revision 1.167  2008-03-01 12:36:12  glen
- 2.6.24.3 source

Revision 1.166  2008-02-29 15:50:57  czarny
- up to 2.6.22.19

Revision 1.165  2008-02-12 08:34:00  glen
- R: /sbin/depmod, due vserver-packages having provide on module-init-tools

Revision 1.164  2008-02-11 21:03:43  hawk
- removed source symlink from -module-build, causes unfixable broken deps like:
  /home/users/builder/rpm/BUILD/linux-2.6.22 is needed by kernel-desktop-module-build-2.6.22.18-1.i68
- build symlink back to kernel package otherwise -module-build requires
  main kernel package to be installed which is IMO overkill
- release 2

Revision 1.163  2008-02-11 11:58:11  hawk
- blah, updated md5

Revision 1.162  2008-02-11 11:27:23  hawk
- updated to 2.6.22.18, official fix for local root hole

Revision 1.161  2008-02-10 22:05:41  hawk
- unofficial fix for local root hole, release 3

Revision 1.160  2008-02-09 18:56:48  glen
- move source and build symlinks to -module-build

Revision 1.159  2008-02-07 08:53:59  glen
- 2.6.22.17, renum sources

Revision 1.158  2008-02-03 14:17:42  hawk
- removed %ghost %{_kernelsrcdir} from %files, breaks %releq_kernel rpm macro

Revision 1.157  2008-02-02 17:46:15  hawk
- release 4

Revision 1.156  2008-01-25 22:28:14  wolvverine
- add %file: %ghost %{_kernelsrcdir}

Revision 1.155  2008-01-22 10:20:38  glen
- PF_RING.patch is back, content seems valid now

Revision 1.154  2008-01-22 10:13:36  glen
- use source names everywhere for .config

Revision 1.153  2008-01-21 21:02:02  glen
- use %{pname} as our %{name} changes when building for laptop, noticed by @PaSzCzUs

Revision 1.152  2008-01-21 20:56:38  glen
- play with gcc4 bcond

Revision 1.151  2008-01-21 10:07:39  glen
- add gcc4 bcond

Revision 1.150  2008-01-19 18:22:36  glen
- um, no vmlinux on th-ppc

Revision 1.149  2008-01-19 17:35:38  glen
- now that there's only main one package, drop version macros

Revision 1.148  2008-01-19 17:20:04  glen
- use %{name} macro

Revision 1.147  2008-01-19 16:42:28  glen
- netfilter provide with alt kernel support

Revision 1.146  2008-01-19 16:21:17  glen
- 2.6.22.16
  CVE-2008-0001

Revision 1.145  2007-12-25 23:10:33  glen
- add P: kernel(netfilter) back (iptables uses it)

Revision 1.144  2007-12-21 07:40:30  glen
- rel 3

Revision 1.143  2007-12-18 20:50:53  glen
- drop dozen of provides, leave only internal deps
- besides by pld policy shouldn't depend on kernel package(s)
- drop unused/pointless macros
- rel 2

Revision 1.142  2007-12-16 22:01:54  glen
- ppc arch off (temporarily until somebody fixes)

Revision 1.141  2007-12-15 14:29:01  glen
- 2.6.22.15

Revision 1.140  2007-11-25 06:16:10  wolvverine
- remove duplicate

Revision 1.139  2007-11-21 19:12:04  glen
- 2.6.22.14

Revision 1.138  2007-11-19 11:52:48  glen
- don't enforce suspend2 from .spec, user should choose suspend/tuxonice from geninitrd config. bug #70

Revision 1.137  2007-11-17 07:56:47  hawk
- updated to 2.6.22.13

Revision 1.136  2007-11-06 18:01:26  glen
- well, it is mostly ready

Revision 1.135  2007/11/05 19:36:54  glen
- 2.6.22.12

Revision 1.134  2007/11/05 19:33:59  glen
- add TIOCGDEV.patch

Revision 1.133  2007/11/02 18:42:19  glen
- update to 2.6.22.11, PF_RING patch seems invalid

Revision 1.132  2007/10/28 19:39:00  glen
- cleanups

Revision 1.131  2007/10/22 19:00:31  glen
- re-adapter after fixed adapter.awk

Revision 1.130  2007/10/22 18:58:14  glen
- keep also BR: module-init-tools
- adapter

Revision 1.129  2007/10/22 08:15:08  glen
- BR /sbin/depmod instead of module-init-tools due vserver-packages provides module-init-tools

Revision 1.128  2007/10/21 14:57:02  czarny
- up to .10
- anti 'CPU too old' fix from LKML http://lkml.org/lkml/2007/9/18/301

Revision 1.127  2007/10/21 14:39:02  glen
- cleanup patch that doesn't exist

Revision 1.126  2007/09/27 08:10:40  czarny
- up to .9

Revision 1.125  2007/09/23 10:50:57  czarny
- up to 2.6.22.7
- oh -- another security fix? Don't they do security assessment *before* releaseing their code?

Revision 1.124  2007/08/31 07:48:19  czarny
- up to 2.6.22.6
- so many versions is a farse

Revision 1.123  2007/08/30 10:38:43  czarny
- enable bootsplash all the way
- indicate what splash is used (for splashy and usplash later use)
- require newest geninitrd (8702) to generate bootsplash/fbsplash
- suggest bootsplash/splashutils for bootsplash/splashutils versions
- removed forgotten smp Feature
- geninitrd with initramfs by default, suspend2 and bootsplash/fbsplash accordingly

Revision 1.122  2007/08/30 08:31:11  glen
- rndis_host patch from synce

Revision 1.121  2007/08/30 06:25:11  czarny
- typo with ppc-ICE patch

Revision 1.120  2007/08/29 10:31:35  glen
- drop bogus todo

Revision 1.119  2007/08/29 10:31:16  glen
- add HZ back to ix86 but i386
- no obvious reasons for doing mrproper and other partial rules, so do just silentoldconfig

Revision 1.118  2007/08/28 17:46:50  czarny
- pcc ICE patch
- comments for almost all patches (source link)
- proper fbsplash/bootsplash handling
- OOPS TODO -- why the fuck it oopses ?

Revision 1.117  2007/08/28 06:39:56  czarny
- whola lotta patches from kernel.spec to desktop
- todos updated (mainly patches)
- kernel built and works for me for about a weekd now
- forgot to commit earlier, sry ;/

Revision 1.116  2007/08/23 05:33:44  czarny
- up to .5; fck -- 3 version changes in one week??

Revision 1.115  2007/08/22 18:57:26  czarny
- wrr patch + config added (builds & works)
- generic kernel.spec todo specified patch by patch

Revision 1.114  2007/08/21 21:56:27  adamg
- use NO_HZ on i386
- disable e1000 on ppc, causes ICE

Revision 1.113  2007/08/21 15:11:27  adamg
- patch85 info (from Wojciech Blaszkowski)

Revision 1.112  2007/08/21 07:27:20  adamg
- updated to 2.6.22.4 (CVE-2007-3848)

Revision 1.111  2007/08/20 14:26:16  adamg
- typo

Revision 1.110  2007/08/19 11:01:43  adamg
- netfilter todo entry done
- apply Jens Axboe's fcache patch unconditionally (not part of ck)
- nock-compat patch no longer needed (was related to fcache patch which
  we apply unconditionally now)
- fbsplash updated wrt fcache patch
- preemptrt updated - applies, but conflicts with other patches

Revision 1.109  2007/08/18 20:35:02  adamg
- inconsistency fixed - we were using %{arch}-smp.config while in %build
  we were trying to read %{arch}.config

Revision 1.108  2007/08/18 18:11:55  adamg
- netfilter update (20061213 snap from kernel.spec:LINUX_2_6)
- temporary disable nock-compat patch
- atmdd, small-fixes, squashfs, tahoe9xx, esfq patches updated to 2.6.22
- builds

Revision 1.107  2007/08/18 09:59:16  glen
- -source is not needed to compile C programs

Revision 1.106  2007/08/16 20:48:50  adamg
- updated to 2.6.22.3

Revision 1.105  2007/08/03 00:35:45  czarny
- up to 2.6.22
- almost all patches upded to the newest versions (netfilter and Patch>90 not done yet)
- no more smp/up build -- smp by default
- comments and todoos added to all revised patches
- supermount-ng added
- NCQ patch for newer nvidia chipsets added
- typos fixed
- unneeded stuff from kernel.spec needed
- most of patches reenabled (like all filesystem, suspend2)
- a hell lot of TODO added
- I'll be off the next week (maybe two), so please someone(tm) try at least port the rest of patches, or even better produce a good default .config

Revision 1.104  2007/05/13 18:44:05  czarny
- fbsplash + vesafb-tng patches updated, active and working

Revision 1.103  2007/03/27 23:10:54  glen
- missing changes

Revision 1.102  2007/03/27 22:44:49  sparky
- lazy update to 2.6.20.4
- build only one of up or smp -> building simplified
- only ck patch and ppc configs prepared

Revision 1.101  2007/02/13 08:06:37  glen
- tabs in preamble

Revision 1.100  2007/02/12 01:06:41  baggins
- converted to UTF-8

Revision 1.99  2007/02/10 23:42:40  blaass
- added Wireless fix, bcm43xx-pcie

Revision 1.98  2006/12/19 17:29:32  adamg
- updated to 2.6.18.6 (resolves CVE-2006-6106)

Revision 1.97  2006/12/19 01:20:56  adamg
- hdaps-protect.patch reapplied

Revision 1.96  2006/12/19 01:15:05  adamg
- typo in kernel_release (should be %{version}_%{alt_kernel}, not -%{alt_kernel})

Revision 1.95  2006/12/18 23:13:13  glen
- skip stripping sourcedir

Revision 1.94  2006/12/15 19:02:58  glen
- use macros for same location to be able to merge different kernel specs

Revision 1.93  2006/12/15 18:21:13  glen
- unify /usr/src/linux paths (/usr vs %{_prefix})

Revision 1.92  2006/12/15 17:40:34  glen
- partial adapter

Revision 1.91  2006/12/05 23:17:15  glen
- hardlink over copy speedup from kernel.spec

Revision 1.90  2006/11/29 23:43:59  sparky
- 2.6.18.4

Revision 1.89  2006/11/27 02:30:14  sparky
- space

Revision 1.88  2006/11/27 02:24:12  sparky
- use suspend_kernel macro

Revision 1.87  2006/11/25 13:51:11  lmasko
- suspend2 up to 2.2.9 for 2.6.18.3

Revision 1.86  2006/11/22 13:47:49  sparky
- cxacru.c patch metged to small_fixes - please, don't use separated
  patches for so small changes

Revision 1.85  2006/11/22 09:21:03  shadzik
- add support for ZXDSL modems (like those new TPSA offers)

Revision 1.84  2006/11/21 16:59:19  sparky
- up to 2.6.18.3
- suspend2 up to 2.2.8.5 for 2.6.18.2

Revision 1.83  2006/11/21 16:30:15  sparky
- kernel-desktop-suspend2 patch removed

Revision 1.82  2006/11/19 16:14:53  sparky
- put some features in descriptoin

Revision 1.81  2006/11/19 15:09:09  sparky
- add _rt to name of preemptrt-enabled kernel

Revision 1.80  2006/11/19 06:02:34  sparky
- enable sk98lin patch

Revision 1.79  2006/11/19 03:09:32  sparky
- some patches updated

Revision 1.78  2006/11/18 23:17:17  sparky
- fbsplash patch applies

Revision 1.77  2006/11/18 22:49:14  sparky
- nock-compat updated, don't let build with both ck and rt

Revision 1.76  2006/11/18 12:55:07  lmasko
- Updated patch for vesafb_tng - adjusted the 1.0-rc2-2.6.19-rc2 version, seems to work.

Revision 1.75  2006/11/18 00:18:28  sparky
- better fix

Revision 1.74  2006/11/17 23:07:04  lmasko
- Small fix for naming: vmlinux.old-desktop -> vmlinux-desktop.old

Revision 1.73  2006/11/17 22:27:03  sparky
- make include/linux/utsrelease.h (not tested)

Revision 1.72  2006/11/17 21:02:30  lmasko
- Small fix in naming convention for /boot/{initrd,System.map}-{desktop,laptop}.old files

Revision 1.71  2006/11/15 00:37:33  sparky
- do not comment grsec patch, so building will fail at the begginind, not
  at the end

Revision 1.70  2006/11/07 04:49:47  sparky
- fix depmod; 2 more patches to update

Revision 1.69  2006/11/07 00:29:35  sparky
- use HOSTCC and CC if not cross-compiling

Revision 1.68  2006/11/06 21:51:44  sparky
- marked patches to update

Revision 1.67  2006/11/06 20:35:04  sparky
- move suspend2 before preemptrt

Revision 1.66  2006/11/06 19:56:46  sparky
- starting update to 2.6.18.2, old branched as LINUX_2_6_17

Revision 1.65  2006/10/18 08:39:42  adamg
- updated to 2.6.17.14 (solves CVE-2006-4623); works here

Revision 1.64  2006/09/29 20:09:57  sparky
- let it be rel 1

Revision 1.63  2006/09/28 16:45:14  sparky
- P: kernel(netfilter)

Revision 1.62  2006/09/28 15:27:27  sparky
- don't use localversion, only LOCALVERSION in config file
- prevent building config twice

Revision 1.61  2006/09/13 17:28:00  sparky
- use localversion without smp suffix for generating include/linux/version.h

Revision 1.60  2006/09/09 21:45:20  adamg
- updated to 2.6.17.13

Revision 1.59  2006/09/03 13:17:05  sparky
- netfilter back in main package
- other way of fixing smp 'name vs dir'
- move miropcm20-rds.ko to sound-oss
- sound/pcmcia moved to pcmcia package (now there are missing symbols in
  pcmcia subpackage if sound-alsa is not installed)
- moved saa7134-alsa.ko and cx88-alsa.ko to sound-alsa

Revision 1.58  2006/09/02 21:29:22  paszczus
- fixed SMP modules directory (big thx to pepe (at) apollo.pl)

Revision 1.57  2006/08/29 17:55:25  sparky
- up to 2.6.17.11

Revision 1.56  2006/08/19 09:43:13  adamg
- updated to 2.6.17.9 (CVE-2006-4093, ppc only)

Revision 1.55  2006/08/16 09:33:29  adamg
- dmi-decode-and-save-oem-string-information patch from tp_smapi added
  (consult the patch for details)
- release 0.2

Revision 1.54  2006/08/15 11:08:25  adamg
- hdaps_protect.patch dropped - it is provided as a kernel module by
  kernel-misc-tp_smapi.spec (and has to be, otherwise it conflicts with
  thinkpad_ec module)

Revision 1.53  2006/08/07 14:15:47  adamg
- updated to 2.6.17.8

Revision 1.52  2006/08/07 10:44:09  sparky
- fixed %if

Revision 1.51  2006/07/31 11:48:38  sparky
- kernel-desktop-budget-av-compile-fix.patch merged to small_fixes.patch

Revision 1.50  2006/07/31 11:33:45  sparky
- suspend2 up to 2.2.7.3, linus patch removed

Revision 1.49  2006/07/30 16:25:45  patrys
- uses asus patch as patch101

Revision 1.48  2006/07/26 18:47:44  adamg
- updated to 2.6.17.7; works here

Revision 1.47  2006/07/18 02:32:19  sparky
- this one seems to work, let's give him rel 1

Revision 1.46  2006/07/15 20:24:11  adamg
- 2.6.17.6

Revision 1.45  2006/07/15 07:45:05  adamg
- updated to 2.6.17.5 (CVE-2006-3626)

Revision 1.44  2006/07/10 12:23:31  glen
- typo

Revision 1.43  2006/07/09 12:45:52  sparky
- kill evil suspend2 part on ppc (brakes suspend-to-ram)

Revision 1.42  2006/07/07 01:52:19  sparky
- suspend2 up to 2.2.7, use original tarball as there is no need to change anything

Revision 1.41  2006/07/06 22:46:41  sparky
- 2.6.17.4

Revision 1.40  2006/06/30 22:33:31  sparky
- removed suspend2 compatibility patches - not needed anymore
- disabled pom-ng pathes, was disabled in kernel.spec@LINUX_2_6 and i know
  nothing about it

Revision 1.39  2006/06/30 21:24:05  sparky
- up to 2.6.17.3
- change name to kernel-laptop if built --with laptop

Revision 1.38  2006/06/25 16:58:07  adamg
- cluster dir (for kernel-cluster-{cman,dlm})

Revision 1.37  2006/06/24 15:16:12  charles
- unified initrd symlinks (without path)

Revision 1.36  2006/06/24 14:25:06  adamg
- pae bcond

Revision 1.35  2006/06/23 23:33:39  sparky
- rel 0.5: this one (without alterating bconds) works on amd64 and ppc;
  feel free to test ix86 (i don't use it)
  feel free to test suspend2 (seems some kind problematic for me)

Revision 1.34  2006/06/23 22:58:23  sparky
- s/_alt_kernel/alt_kernel/g

Revision 1.33  2006/06/23 22:56:10  sparky
- cleaned bconds: preemptrt of by default, pcmcia and test_build are useless

Revision 1.32  2006/06/23 22:50:46  sparky
- epoch 3, for sync with kernel.spec

Revision 1.31  2006/06/23 20:07:34  sparky
- preempt-nopreempt.config renamed do -nort.config, -common.config removed

Revision 1.30  2006/06/23 19:20:35  sparky
- apply suspend2 before ck, patches done

Revision 1.29  2006/06/23 16:55:45  sparky
- (re)organised patching, NFY

Revision 1.28  2006/06/23 15:22:36  sparky
- suspend2 should work on ppc

Revision 1.27  2006/06/22 22:25:44  charles
- added bootsplash support (with bcond)

Revision 1.26  2006/06/21 17:52:59  sparky
- builds with grsec_minimal: rel 0.3 (ppc still broken)
- added with laptop bcond

Revision 1.25  2006/06/21 14:19:00  sparky
- up to 2.6.17.1, using patch, there is only 1 line changged !

Revision 1.24  2006/06/21 14:05:31  sparky
- added fcache patch

Revision 1.23  2006/06/19 19:11:31  sparky
- disable cpuset_virtualisation patch, smp fail to build

Revision 1.22  2006/06/19 14:01:31  sparky
- reenabled 3 patches

Revision 1.21  2006/06/19 13:00:16  sparky
- patches renamed

Revision 1.20  2006/06/19 11:19:16  sparky
- added with test_build bcond, for testing kernel without preemptrt

Revision 1.19  2006/06/18 13:45:22  sparky
- up to final 2.6.17

Revision 1.18  2006/06/13 19:03:17  sparky
- automatical Kconfig and Makefiles collecting, based on kernel.spec@LINUX_2_6
  WARNING: rpm is loosing some files, -f bug ?

Revision 1.17  2006/06/13 10:06:36  sparky
- reenabled preempt_ppc_fix patch
- /boot/{vmlinu[zx],inidts,System.map} renamed with -desktop suffix, for not
  to conflict with normal kernel

Revision 1.16  2006/06/12 22:55:23  sparky
- (re)organised .config creating

Revision 1.15  2006/06/12 17:05:30  sparky
- apply netfilter patches

Revision 1.14  2006/06/11 21:00:39  sparky
- reiser4 applies and builds

Revision 1.13  2006/06/11 20:19:47  sparky
- fbsplash applies

Revision 1.12  2006/06/11 19:59:28  sparky
- up to 2.6.17-rc6, preempt'rt works fine on amd64, everything else needs work

Revision 1.11  2006/05/03 21:42:39  sparky
- up to 2.6.16.13 !!!
  $ diff -Nur linux-2.6.16.1[23] | wc -l
  58

Revision 1.10  2006/05/02 20:33:33  sparky
- netfilter separated

Revision 1.9  2006/05/02 19:02:15  sparky
- up to 2.6.16.12, patch linux-2.6-alpha-for_each_possible_cpu applied

Revision 1.8  2006/05/02 13:21:07  sparky
- netfilter reverted

Revision 1.7  2006/05/02 01:02:23  shadzik
- de supplement; de typo fixes

Revision 1.6  2006/05/01 23:09:33  sparky
- netfilter throwed

Revision 1.5  2006/05/01 22:36:14  sparky
- added kernel-desktop-preempt_ppc_fix patch, now it build and works on ppc

Revision 1.4  2006/05/01 20:34:14  sparky
- no suspend2 on powerpc: swsusp_arch_resume() and swsusp_arch_suspend() is not
  ported yet from arch/ppc to arch/powerpc

Revision 1.3  2006/05/01 18:59:57  sparky
- linux-alpha-isa patch is not needed
- apply all paches an every arch

Revision 1.2  2006/05/01 17:06:17  sparky
- stupid rpm!:
  "error: bad date in %changelog: NEW, my vision of desktop-oriented kernel:"

Revision 1.1  2006/05/01 16:37:54  sparky
-- NEW, my vision of desktop-oriented kernel:
- only for desktop archs (x86_64, x86, ppc)
- realtime preemption
- only minimal grsec, or none
- no xen/vserver stuff
- suspend2 on by default
- can coexist on builders and on desktpos with main kernel with same
  version-release, and modules can be build for both
- NFY, because preempt fails to boot on amd64 (other archs not tested yet)
- not yet existing parches use from kernel.spec @ LINUX_2_6
- i'm sure i've missed something
